/**
*	main.c
*	W5100eXg[`
*	copyright (c)Junnichi Tomaru
*/
#define	_GLOBAL_DEFINED
#include	"main.h"


/**
*	ϐ
*	 in	Ȃ
*	out	Ȃ
*/
void	valinit( void )
{
	rxhp = rxtp = rxct = 0;
}


/**
*	
*	DDR* 0: 1:o
*	 in	Ȃ
*	out	Ȃ
*/
void	internalinit( void )
{
	const int	brr[] = { 1023, 511, 255, 127, 63, 31, 20, 10 };/* {[[ge[u */
	char	d;

	PRR = 0xc9;		/* TMR0,SPI,USART */
	PORTB = 0x05;		/*  */
	PORTC = 0x3f;		/* PC0-5vAbv */
	PORTD = 0xfa;		/* TxD=H */
	DDRB = 0x2f;		/*  */
	DDRC = 0x00;		/* Sē */
	DDRD = 0xfa;		/*  */

	d = (~PINC) & 0x7;
	UBRR0 = brr[d];		/* 20MHz */
	UCSR0C = 0x6;		/* 8bit,stop1,Pn */
	UCSR0B = 0x98;		/* RxEN,TxEN,RxIEN */

	SPCR = 0x50;		/* SPIA}X^A2ɐݒ*/
	SPSR = 0x1;		/* X2 */

	TCNT0 = 0;		/* TCNT0 ؾ */
	TCCR0A = 0x00;		/* ʏ퓮 */
	TCCR0B = 0x04;		/* f/256 */
	TIMSK0 = 0x1;		/* I[o[t[ */

	valinit( );
}

swbool	s2en;

/**
*	R}h
*	 in	Ȃ
*	out	Ȃ
*/
void	commandseq( void )
{
	char	c, buf[32];
	int	i;

	getsio1( &c );
	if( c == 'O' ){		/* \PbgI[v */
		getsiostr( buf, '\n' );
		i = atoi( buf );
		if( socket( SOCKET2, SOCK_STREAM, i, 0 ) != INVALID_SOCKET ){
			setsiostr( "OK\r\n" );
		}
		else{
			setsiostr( "NG\r\n" );
		}
	}
	else if( c == 'C' ){	/* \PbgN[Y */
		if( close( SOCKET2 ) == 0 ){
			setsiostr( "OK\r\n" );
		}
		else{
			setsiostr( "NG\r\n" );
		}
		s2en = off;
		PORTD |= ( EST2 | SOCK2 );
	}
	else if( c == 'L' ){	/* LISTEN */
		if( listen( SOCKET2 ) == 0 ){	/* \Pbg2 */
			PORTD &= ~(SOCK2);
			s2en = on;
			setsiostr( "OK\r\n" );
		}
		else{
			setsiostr( "NG\r\n" );
		}
	}
	else if( c == 'D' ){	/* DISCONNECT */
		if( disconnect( SOCKET2 ) == 0 ){
			setsiostr( "OK\r\n" );
		}
		else{
			setsiostr( "NG\r\n" );
		}
	}
	else if( c == 'S' ){	/* M */
		getsiostr( buf, '\n' );
		send( SOCKET2, buf, strlen( buf ));
	}
}


/**
*	C
*	 in	Ȃ
*	out	1
*/
int	main( void )
{
	char	ir, sr, flg, buf[32];
	dword	addr;
	word	port;
	swbool	s0en, s1en;
	int	len;

	_di( );
	internalinit( );	/* CPU */
	s2en = off;
	w5100_init( );		/*  */
	w5100_meminit( 0x55, 0x55 );	/*  */
	s0en = off;
	/* \Pbg0 UDP ECHOT[oƂē */
	if( socket( SOCKET0, SOCK_DGRAM, 7, NOOPTION ) != INVALID_SOCKET ){
		PORTB &= ~(SOCK0);
		s0en = on;
	}
	s1en = off;
	/* \Pbg1 TCP ECHOT[oƂē */
	if( socket( SOCKET1, SOCK_STREAM, 7, NOOPTION ) != INVALID_SOCKET ){
		if( listen( SOCKET1 ) == 0 ){	/* \Pbg1 */
			PORTD &= ~(SOCK1);
			s1en = on;
		}
	}
	flg = 0;
	_ei( );
	while( 1 ){
		if( s0en ){
			if( getsn_ir( SOCKET0 ) & Sn_IR_RECV ){	
				setsn_ir( SOCKET0, Sn_IR_RECV );
				len = recvfrom( SOCKET0, buf, 32, &addr, &port );
				if( len != SOCKET_ERROR ){
					sendto( SOCKET0, buf, len, addr, port );
				}
			}
		}
		sr = getsn_sr( SOCKET1 );
		if( s1en ){
			ir = getsn_ir( SOCKET1 );
			if( ir & Sn_IR_CON ){	/* \Pbg1ڑ */
				setsn_ir( SOCKET1, Sn_IR_CON );
				flg = 1;
				PORTD &= ~(EST1);
			}
			if( flg && ( ir & Sn_IR_RECV )){	/* \Pbg1M */
				setsn_ir( SOCKET1, Sn_IR_RECV );
				len = recv( SOCKET1, buf, 32 );
				if( len != SOCKET_ERROR ){
					send( SOCKET1, buf, len );
				}
			}
			if( sr == SOCK_CLOSE_WAIT ){	/* ؒfvM */
				close( SOCKET1 );
				s1en = off;
				PORTD |= ( EST1 | SOCK1 );
			}
		}
		else if( sr == SOCK_CLOSED ){	/* ؒf */
			s1en = off;
			if( socket( SOCKET1, SOCK_STREAM, 7, 0 ) != INVALID_SOCKET ){/* ăI[v */
				if( listen( SOCKET1 ) == 0 ){	/* \PbgPT[o */
					PORTD &= ~(SOCK1);
					s1en = on;
				}
			}
		}
		if( s2en ){
			ir = getsn_ir( SOCKET2 );
			if( ir & Sn_IR_CON ){	/* \Pbg2ڑ */
				setsn_ir( SOCKET1, Sn_IR_CON );
				flg = 1;
				PORTD &= ~(EST2);
			}
			if( flg && ( ir & Sn_IR_RECV )){	/* \Pbg2M */
				setsn_ir( SOCKET2, Sn_IR_RECV );
				len = recv( SOCKET2, buf, 32 );
				if( len != SOCKET_ERROR ){
					buf[strlen(buf)] = '\0';
					setsiostr( buf );
				}
			}
			if( getsn_sr( SOCKET2 ) == SOCK_CLOSE_WAIT ){	/* ؒfvM */
				close( SOCKET2 );
				setsiostr( "CLOSED\r\n" );
				s2en = off;
				PORTD |= ( EST2 | SOCK2 );
			}
		}
		if( getsiocount( ) != 0 ){	/* R}h */
			commandseq( );
		}
	}

	return	1;
}


/* end of main.c */
